package me.lensfrex.littlebusters.api.v1.login;

import com.google.gson.Gson;
import com.google.gson.JsonParseException;
import com.google.gson.annotations.SerializedName;
import com.sun.org.apache.xalan.internal.xsltc.trax.XSLTCSource;
import jakarta.ws.rs.POST;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.Produces;
import jakarta.ws.rs.core.MediaType;
import me.lensfrex.littlebusters.api.v1.dao.UserInformation;
import me.lensfrex.littlebusters.api.v1.responses.LoginResponseData;
import me.lensfrex.littlebusters.api.v1.responses.general.ErrorResponse;
import me.lensfrex.littlebusters.api.v1.responses.general.ResponseBase;
import me.lensfrex.littlebusters.api.v1.utils.InputChecker;
import me.lensfrex.littlebusters.api.v1.utils.MyBatisUtil;
import org.apache.ibatis.session.SqlSession;
import org.mindrot.jbcrypt.BCrypt;

import java.math.BigInteger;
import java.time.LocalDate;
import java.util.HashMap;
import java.util.Map;

@Path("/login")
public class Login {
    private final static Gson gson = new Gson();

    @POST
    @Produces(MediaType.APPLICATION_JSON)
    public String login(String request) {
        LoginRequestBody loginRequestBody;
        try {
            loginRequestBody = gson.fromJson(request, LoginRequestBody.class);
            if (InputChecker.hasInvalidChar(loginRequestBody.userName) ||
                    InputChecker.hasInvisibleChar(loginRequestBody.password)) {
                ErrorResponse errorResponse = new ErrorResponse(100, "请求的用户名或密码非法");

                return gson.toJson(errorResponse);
            }

            if ()
            LoginResponseData loginResponseData = new LoginResponseData(((BigInteger) selectResult.get("uid")).intValue(), (String) selectResult.get("password"), LocalDate.now().toString());
            ResponseBase<LoginResponseData> response = new ResponseBase<>(200, "success", loginResponseData);

            return gson.toJson(response);

        } catch (JsonParseException e) {
            System.err.println(request);

            ErrorResponse errorResponse = new ErrorResponse(300, "请求的数据格式不对");
            return gson.toJson(errorResponse);
        } catch (Exception e) {
            System.err.println(request);
            System.err.println(e.getMessage());

            ErrorResponse errorResponse = new ErrorResponse(400, "服务器内部错误，请联系那个背锅的家伙。");
            return gson.toJson(errorResponse);
        }
    }

    public static class LoginRequestBody {
        @SerializedName("user_name")
        private String userName;

        private String password;

        public LoginRequestBody(String userName, String password) {
            this.userName = userName;
            this.password = password;
        }

        public String getUserName() {
            return userName;
        }

        public void setUserName(String userName) {
            this.userName = userName;
        }

        public String getPassword() {
            return password;
        }

        public void setPassword(String password) {
            this.password = password;
        }
    }
}