package me.lensfrex.littlebusters.api.v1.responses;

import com.google.gson.annotations.SerializedName;

/**
 * 登录响应中data字段的对象
 */
public class LoginResponseData {
    /**
     * 登录用户的uid
     */
    private int uid;

    /**
     * 用户本次登录得到的token
     */
    @SerializedName("access_token")
    private String accessToken;

    /**
     * 用户此次得到的token的过期时间
     */
    @SerializedName("expired_at")
    private String expiredAt;

    public LoginResponseData(int uid, String accessToken, String expiredAt) {
        this.uid = uid;
        this.accessToken = accessToken;
        this.expiredAt = expiredAt;
    }

    public int getUid() {
        return uid;
    }

    public void setUid(int uid) {
        this.uid = uid;
    }

    public String getAccessToken() {
        return accessToken;
    }

    public void setAccessToken(String accessToken) {
        this.accessToken = accessToken;
    }

    public String getExpiredAt() {
        return expiredAt;
    }

    public void setExpiredAt(String expiredAt) {
        this.expiredAt = expiredAt;
    }
}
